diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/he/he-phy.h ns-3.34/src/wifi/model/he/he-phy.h
--- ns-3.33/src/wifi/model/he/he-phy.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/he/he-phy.h	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,440 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 Orange Labs
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Authors: Rediet <getachew.redieteab@orange.com>
+ *          Sébastien Deronne <sebastien.deronne@gmail.com> (for logic ported from wifi-phy and spectrum-wifi-phy)
+ */
+
+#ifndef HE_PHY_H
+#define HE_PHY_H
+
+#include "ns3/vht-phy.h"
+#include "ns3/wifi-phy-band.h"
+#include "ns3/callback.h"
+
+/**
+ * \file
+ * \ingroup wifi
+ * Declaration of ns3::HePhy class
+ * and ns3::HeSigAParameters struct.
+ */
+
+namespace ns3 {
+
+/**
+ * This defines the BSS membership value for HE PHY.
+ */
+#define HE_PHY 125
+
+/**
+ * Parameters for received HE-SIG-A for OBSS_PD based SR
+ */
+struct HeSigAParameters
+{
+  double rssiW;     ///< RSSI in W
+  uint8_t bssColor; ///< BSS color
+};
+
+/**
+ * \brief PHY entity for HE (11ax)
+ * \ingroup wifi
+ *
+ * HE PHY is based on VHT PHY.
+ *
+ * Refer to P802.11ax/D4.0, clause 27.
+ */
+class HePhy : public VhtPhy
+{
+public:
+  /**
+   * Callback upon end of HE-SIG-A
+   *
+   * arg1: Parameters of HE-SIG-A
+   */
+  typedef Callback<void, HeSigAParameters> EndOfHeSigACallback;
+
+  /**
+   * Constructor for HE PHY
+   *
+   * \param buildModeList flag used to add HE modes to list (disabled
+   *                      by child classes to only add child classes' modes)
+   */
+  HePhy (bool buildModeList = true);
+  /**
+   * Destructor for HE PHY
+   */
+  virtual ~HePhy ();
+
+  WifiMode GetSigMode (WifiPpduField field, const WifiTxVector& txVector) const override;
+  WifiMode GetSigAMode (void) const override;
+  WifiMode GetSigBMode (const WifiTxVector& txVector) const override;
+  const PpduFormats & GetPpduFormats (void) const override;
+  Time GetLSigDuration (WifiPreamble preamble) const override;
+  Time GetTrainingDuration (const WifiTxVector& txVector,
+                            uint8_t nDataLtf,
+                            uint8_t nExtensionLtf = 0) const override;
+  Time GetSigADuration (WifiPreamble preamble) const override;
+  Time GetSigBDuration (const WifiTxVector& txVector) const override;
+  Ptr<WifiPpdu> BuildPpdu (const WifiConstPsduMap & psdus,
+                           const WifiTxVector& txVector,
+                           Time ppduDuration) override;
+  Ptr<const WifiPsdu> GetAddressedPsduInPpdu (Ptr<const WifiPpdu> ppdu) const override;
+  void StartReceivePreamble (Ptr<WifiPpdu> ppdu,
+                             RxPowerWattPerChannelBand rxPowersW,
+                             Time rxDuration) override;
+  void CancelAllEvents (void) override;
+  uint16_t GetStaId (const Ptr<const WifiPpdu> ppdu) const override;
+  uint16_t GetMeasurementChannelWidth (const Ptr<const WifiPpdu> ppdu) const override;
+  void StartTx (Ptr<WifiPpdu> ppdu) override;
+  Time CalculateTxDuration (WifiConstPsduMap psduMap, const WifiTxVector& txVector, WifiPhyBand band) const override;
+
+  /**
+   * \return the BSS color of this PHY.
+   */
+  uint8_t GetBssColor (void) const;
+
+  /**
+   * \param ppduDuration the duration of the HE TB PPDU
+   * \param band the frequency band being used
+   *
+   * \return the L-SIG length value corresponding to that HE TB PPDU duration.
+   */
+  static uint16_t ConvertHeTbPpduDurationToLSigLength (Time ppduDuration, WifiPhyBand band);
+  /**
+   * \param length the L-SIG length value
+   * \param txVector the TXVECTOR used for the transmission of this HE TB PPDU
+   * \param band the frequency band being used
+   *
+   * \return the duration of the HE TB PPDU corresponding to that L-SIG length value.
+   */
+  static Time ConvertLSigLengthToHeTbPpduDuration (uint16_t length, const WifiTxVector& txVector, WifiPhyBand band);
+  /**
+   * \param txVector the transmission parameters used for the HE TB PPDU
+   *
+   * \return the duration of the non-OFDMA portion of the HE TB PPDU.
+   */
+  Time CalculateNonOfdmaDurationForHeTb (const WifiTxVector& txVector) const;
+
+  /**
+   * Get the band in the TX spectrum associated with the RU used by the PSDU
+   * transmitted to/by a given STA in a DL MU PPDU/HE TB PPDU
+   *
+   * \param txVector the TXVECTOR used for the transmission
+   * \param staId the STA-ID of the station
+   *
+   * \return the RU band in the TX spectrum
+   */
+  WifiSpectrumBand GetRuBandForTx (const WifiTxVector& txVector, uint16_t staId) const;
+  /**
+   * Get the band in the RX spectrum associated with the RU used by the PSDU
+   * transmitted to/by a given STA in a DL MU PPDU/HE TB PPDU
+   *
+   * \param txVector the TXVECTOR used for the transmission
+   * \param staId the STA-ID of the station
+   *
+   * \return the RU band in the RX spectrum
+   */
+  WifiSpectrumBand GetRuBandForRx (const WifiTxVector& txVector, uint16_t staId) const;
+  /**
+   * Get the band used to transmit the non-OFDMA part of an HE TB PPDU.
+   *
+   * \param txVector the TXVECTOR used for the transmission
+   * \param staId the STA-ID of the station taking part of the UL MU
+   *
+   * \return the spectrum band used to transmit the non-OFDMA part of an HE TB PPDU
+   */
+  WifiSpectrumBand GetNonOfdmaBand (const WifiTxVector& txVector, uint16_t staId) const;
+  /**
+   * Get the width in MHz of the non-OFDMA portion of an HE TB PPDU
+   *
+   * \param ru the RU in which the HE TB PPDU is sent
+   * \return the width in MHz of the non-OFDMA portion of an HE TB PPDU
+   */
+  uint16_t GetNonOfdmaWidth (HeRu::RuSpec ru) const;
+
+  /**
+   * \return the UID of the HE TB PPDU being received
+   */
+  uint64_t GetCurrentHeTbPpduUid (void) const;
+
+  /**
+   * Get the center frequency of the non-OFDMA part of the current TxVector for the
+   * given STA-ID.
+   * Note this method is only to be used for UL MU.
+   *
+   * \param txVector the TXVECTOR that has the RU allocation
+   * \param staId the STA-ID of the station taking part of the UL MU
+   * \return the center frequency in MHz corresponding to the non-OFDMA part of the HE TB PPDU
+   */
+  uint16_t GetCenterFrequencyForNonOfdmaPart (const WifiTxVector& txVector, uint16_t staId) const;
+
+  /**
+   * Set a callback for a end of HE-SIG-A.
+   *
+   * \param callback the EndOfHeSigACallback to set
+   */
+  void SetEndOfHeSigACallback (EndOfHeSigACallback callback);
+
+  /**
+   * Fire a EndOfHeSigA callback (if connected) once HE-SIG-A field has been received.
+   * This method is scheduled immediatly after end of HE-SIG-A, once
+   * field processing is finished.
+   *
+   * \param params the HE-SIG-A parameters
+   */
+  void NotifyEndOfHeSigA (HeSigAParameters params);
+
+  /**
+   * Initialize all HE modes.
+   */
+  static void InitializeModes (void);
+  /**
+   * Return the HE MCS corresponding to
+   * the provided index.
+   *
+   * \param index the index of the MCS
+   * \return an HE MCS
+   */
+  static WifiMode GetHeMcs (uint8_t index);
+
+  /**
+   * Return MCS 0 from HE MCS values.
+   *
+   * \return MCS 0 from HE MCS values
+   */
+  static WifiMode GetHeMcs0 (void);
+  /**
+   * Return MCS 1 from HE MCS values.
+   *
+   * \return MCS 1 from HE MCS values
+   */
+  static WifiMode GetHeMcs1 (void);
+  /**
+   * Return MCS 2 from HE MCS values.
+   *
+   * \return MCS 2 from HE MCS values
+   */
+  static WifiMode GetHeMcs2 (void);
+  /**
+   * Return MCS 3 from HE MCS values.
+   *
+   * \return MCS 3 from HE MCS values
+   */
+  static WifiMode GetHeMcs3 (void);
+  /**
+   * Return MCS 4 from HE MCS values.
+   *
+   * \return MCS 4 from HE MCS values
+   */
+  static WifiMode GetHeMcs4 (void);
+  /**
+   * Return MCS 5 from HE MCS values.
+   *
+   * \return MCS 5 from HE MCS values
+   */
+  static WifiMode GetHeMcs5 (void);
+  /**
+   * Return MCS 6 from HE MCS values.
+   *
+   * \return MCS 6 from HE MCS values
+   */
+  static WifiMode GetHeMcs6 (void);
+  /**
+   * Return MCS 7 from HE MCS values.
+   *
+   * \return MCS 7 from HE MCS values
+   */
+  static WifiMode GetHeMcs7 (void);
+  /**
+   * Return MCS 8 from HE MCS values.
+   *
+   * \return MCS 8 from HE MCS values
+   */
+  static WifiMode GetHeMcs8 (void);
+  /**
+   * Return MCS 9 from HE MCS values.
+   *
+   * \return MCS 9 from HE MCS values
+   */
+  static WifiMode GetHeMcs9 (void);
+  /**
+   * Return MCS 10 from HE MCS values.
+   *
+   * \return MCS 10 from HE MCS values
+   */
+  static WifiMode GetHeMcs10 (void);
+  /**
+   * Return MCS 11 from HE MCS values.
+   *
+   * \return MCS 11 from HE MCS values
+   */
+  static WifiMode GetHeMcs11 (void);
+
+  /**
+   * Return the coding rate corresponding to
+   * the supplied HE MCS index. This function is used
+   * as a callback for WifiMode operation.
+   *
+   * \param mcsValue the MCS index
+   * \return the coding rate.
+   */
+  static WifiCodeRate GetCodeRate (uint8_t mcsValue);
+  /**
+   * Return the constellation size corresponding
+   * to the supplied HE MCS index. This function is used
+   * as a callback for WifiMode operation.
+   *
+   * \param mcsValue the MCS index
+   * \return the size of modulation constellation.
+   */
+  static uint16_t GetConstellationSize (uint8_t mcsValue);
+  /**
+   * Return the PHY rate corresponding to the supplied HE MCS
+   * index, channel width, guard interval, and number of
+   * spatial stream. This function calls HtPhy::CalculatePhyRate
+   * and is mainly used as a callback for WifiMode operation.
+   *
+   * \param mcsValue the HE MCS index
+   * \param channelWidth the considered channel width in MHz
+   * \param guardInterval the considered guard interval duration in nanoseconds
+   * \param nss the considered number of stream
+   *
+   * \return the physical bit rate of this signal in bps.
+   */
+  static uint64_t GetPhyRate (uint8_t mcsValue, uint16_t channelWidth, uint16_t guardInterval, uint8_t nss);
+  /**
+   * Return the PHY rate corresponding to
+   * the supplied TXVECTOR for the STA-ID.
+   *
+   * \param txVector the TXVECTOR used for the transmission
+   * \param staId the station ID for MU (unused if SU)
+   * \return the physical bit rate of this signal in bps.
+   */
+  static uint64_t GetPhyRateFromTxVector (const WifiTxVector& txVector, uint16_t staId = SU_STA_ID);
+  /**
+   * Return the data rate corresponding to
+   * the supplied TXVECTOR for the STA-ID.
+   *
+   * \param txVector the TXVECTOR used for the transmission
+   * \param staId the station ID for MU (unused if SU)
+   * \return the data bit rate in bps.
+   */
+  static uint64_t GetDataRateFromTxVector (const WifiTxVector& txVector, uint16_t staId = SU_STA_ID);
+  /**
+   * Return the data rate corresponding to
+   * the supplied HE MCS index, channel width,
+   * guard interval, and number of spatial
+   * streams.
+   *
+   * \param mcsValue the MCS index
+   * \param channelWidth the channel width in MHz
+   * \param guardInterval the guard interval duration in nanoseconds
+   * \param nss the number of spatial streams
+   * \return the data bit rate in bps.
+   */
+  static uint64_t GetDataRate (uint8_t mcsValue, uint16_t channelWidth, uint16_t guardInterval, uint8_t nss);
+  /**
+   * Calculate the rate in bps of the non-HT Reference Rate corresponding
+   * to the supplied HE MCS index. This function calls CalculateNonHtReferenceRate
+   * and is used as a callback for WifiMode operation.
+   *
+   * \param mcsValue the HE MCS index
+   * \return the rate in bps of the non-HT Reference Rate.
+   */
+  static uint64_t GetNonHtReferenceRate (uint8_t mcsValue);
+  /**
+   * Check whether the combination of <MCS, channel width, NSS> is allowed.
+   * This function is used as a callback for WifiMode operation, and always
+   * returns true since there is no limitation for any MCS in HePhy.
+   *
+   * \param channelWidth the considered channel width in MHz
+   * \param nss the considered number of streams
+   * \returns true.
+   */
+  static bool IsModeAllowed (uint16_t channelWidth, uint8_t nss);
+
+protected:
+  PhyFieldRxStatus ProcessSigA (Ptr<Event> event, PhyFieldRxStatus status) override;
+  PhyFieldRxStatus ProcessSigB (Ptr<Event> event, PhyFieldRxStatus status) override;
+  Ptr<Event> DoGetEvent (Ptr<const WifiPpdu> ppdu, RxPowerWattPerChannelBand rxPowersW) override;
+  bool IsConfigSupported (Ptr<const WifiPpdu> ppdu) const override;
+  void DoStartReceivePayload (Ptr<Event> event) override;
+  std::pair<uint16_t, WifiSpectrumBand> GetChannelWidthAndBand (const WifiTxVector& txVector, uint16_t staId) const override;
+  void DoEndReceivePayload (Ptr<const WifiPpdu> ppdu) override;
+  void DoResetReceive (Ptr<Event> event) override;
+  void DoAbortCurrentReception (WifiPhyRxfailureReason reason) override;
+  uint64_t ObtainNextUid (const WifiTxVector& txVector) override;
+  Ptr<SpectrumValue> GetTxPowerSpectralDensity (double txPowerW, Ptr<const WifiPpdu> ppdu) const override;
+  uint32_t GetMaxPsduSize (void) const override;
+  WifiConstPsduMap GetWifiConstPsduMap (Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector) const override;
+
+  /**
+   * Start receiving the PSDU (i.e. the first symbol of the PSDU has arrived) of an UL-OFDMA transmission.
+   * This function is called upon the RX event corresponding to the OFDMA part of the UL MU PPDU.
+   *
+   * \param event the event holding incoming OFDMA part of the PPDU's information
+   */
+  void StartReceiveOfdmaPayload (Ptr<Event> event);
+
+  /**
+   * Return the rate (in bps) of the non-HT Reference Rate
+   * which corresponds to the supplied code rate and
+   * constellation size.
+   *
+   * \param codeRate the convolutional coding rate
+   * \param constellationSize the size of modulation constellation
+   * \returns the rate in bps.
+   *
+   * To convert an HE MCS to its corresponding non-HT Reference Rate
+   * use the modulation and coding rate of the HT MCS
+   * and lookup in Table 10-10 of IEEE P802.11ax/D6.0.
+   */
+  static uint64_t CalculateNonHtReferenceRate (WifiCodeRate codeRate, uint16_t constellationSize);
+  /**
+   * \param channelWidth the channel width in MHz
+   * \return he number of usable subcarriers for data
+   */
+  static uint16_t GetUsableSubcarriers (uint16_t channelWidth);
+
+  uint64_t m_previouslyTxPpduUid;  //!< UID of the previously sent PPDU, used by AP to recognize response HE TB PPDUs
+  uint64_t m_currentHeTbPpduUid;   //!< UID of the HE TB PPDU being received
+
+  std::map <uint16_t /* STA-ID */, EventId> m_beginOfdmaPayloadRxEvents; //!< the beginning of the OFDMA payload reception events (indexed by STA-ID)
+
+  EndOfHeSigACallback m_endOfHeSigACallback; //!< end of HE-SIG-A callback
+
+private:
+  void BuildModeList (void) override;
+  uint8_t GetNumberBccEncoders (const WifiTxVector& txVector) const override;
+  Time GetSymbolDuration (const WifiTxVector& txVector) const override;
+
+  /**
+   * Create and return the HE MCS corresponding to
+   * the provided index.
+   * This method binds all the callbacks used by WifiMode.
+   *
+   * \param index the index of the MCS
+   * \return an HE MCS
+   */
+  static WifiMode CreateHeMcs (uint8_t index);
+
+  static const PpduFormats m_hePpduFormats; //!< HE PPDU formats
+}; //class HePhy
+
+} //namespace ns3
+
+#endif /* HE_PHY_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/he/he-ppdu.cc ns-3.34/src/wifi/model/he/he-ppdu.cc
--- ns-3.33/src/wifi/model/he/he-ppdu.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/he/he-ppdu.cc	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,541 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 Orange Labs
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Rediet <getachew.redieteab@orange.com>
+ *         Muhammad Iqbal Rochman <muhiqbalcr@uchicago.edu>
+ *         Sébastien Deronne <sebastien.deronne@gmail.com> (HeSigHeader)
+ */
+
+#include "ns3/wifi-phy.h"
+#include "ns3/wifi-psdu.h"
+#include "ns3/wifi-utils.h"
+#include "he-phy.h"
+#include "he-ppdu.h"
+#include "ns3/log.h"
+
+namespace ns3 {
+
+NS_LOG_COMPONENT_DEFINE ("HePpdu");
+
+std::ostream& operator<< (std::ostream& os, const HePpdu::TxPsdFlag &flag)
+{
+  switch (flag)
+    {
+      case HePpdu::PSD_NON_HE_TB:
+        return (os << "PSD_NON_HE_TB");
+      case HePpdu::PSD_HE_TB_NON_OFDMA_PORTION:
+        return (os << "PSD_HE_TB_NON_OFDMA_PORTION");
+      case HePpdu::PSD_HE_TB_OFDMA_PORTION:
+        return (os << "PSD_HE_TB_OFDMA_PORTION");
+      default:
+        NS_FATAL_ERROR ("Invalid PSD flag");
+        return (os << "INVALID");
+    }
+}
+
+HePpdu::HePpdu (const WifiConstPsduMap & psdus, const WifiTxVector& txVector, Time ppduDuration,
+                WifiPhyBand band, uint64_t uid, TxPsdFlag flag)
+  : OfdmPpdu (psdus.begin ()->second, txVector, band, uid, false) //don't instantiate LSigHeader of OfdmPpdu
+{
+  NS_LOG_FUNCTION (this << psdus << txVector << ppduDuration << band << uid << flag);
+
+  //overwrite with map (since only first element used by OfdmPpdu)
+  m_psdus.begin ()->second = 0;
+  m_psdus.clear ();
+  m_psdus = psdus;
+  if (IsMu ())
+    {
+      m_muUserInfos = txVector.GetHeMuUserInfoMap ();
+    }
+
+  SetPhyHeaders (txVector, ppduDuration);
+  SetTxPsdFlag (flag);
+}
+
+HePpdu::HePpdu (Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector, Time ppduDuration,
+                WifiPhyBand band, uint64_t uid)
+  : OfdmPpdu (psdu, txVector, band, uid, false) //don't instantiate LSigHeader of OfdmPpdu
+{
+  NS_LOG_FUNCTION (this << psdu << txVector << ppduDuration << band << uid);
+  NS_ASSERT (!IsMu ());
+  SetPhyHeaders (txVector, ppduDuration);
+  SetTxPsdFlag (PSD_NON_HE_TB);
+}
+
+HePpdu::~HePpdu ()
+{
+}
+
+void
+HePpdu::SetPhyHeaders (const WifiTxVector& txVector, Time ppduDuration)
+{
+  NS_LOG_FUNCTION (this << txVector << ppduDuration);
+  uint8_t sigExtension = 0;
+  if (m_band == WIFI_PHY_BAND_2_4GHZ)
+    {
+      sigExtension = 6;
+    }
+  uint8_t m = 0;
+  if ((m_preamble == WIFI_PREAMBLE_HE_SU) || (m_preamble == WIFI_PREAMBLE_HE_TB))
+    {
+      m = 2;
+    }
+  else if (m_preamble == WIFI_PREAMBLE_HE_MU)
+    {
+      m = 1;
+    }
+  else
+    {
+      NS_ASSERT_MSG (false, "Unsupported preamble type");
+    }
+  uint16_t length = ((ceil ((static_cast<double> (ppduDuration.GetNanoSeconds () - (20 * 1000) - (sigExtension * 1000)) / 1000) / 4.0) * 3) - 3 - m);
+  m_lSig.SetLength (length);
+  if (IsDlMu ())
+    {
+      m_heSig.SetMuFlag (true);
+    }
+  else if (!IsUlMu ())
+    {
+      m_heSig.SetMcs (txVector.GetMode ().GetMcsValue ());
+      m_heSig.SetNStreams (txVector.GetNss ());
+    }
+  m_heSig.SetBssColor (txVector.GetBssColor ());
+  m_heSig.SetChannelWidth (m_channelWidth);
+  m_heSig.SetGuardIntervalAndLtfSize (txVector.GetGuardInterval (), 2/*NLTF currently unused*/);
+}
+
+WifiTxVector
+HePpdu::DoGetTxVector (void) const
+{
+  WifiTxVector txVector;
+  txVector.SetPreambleType (m_preamble);
+  txVector.SetMode (HePhy::GetHeMcs (m_heSig.GetMcs ()));
+  txVector.SetChannelWidth (m_heSig.GetChannelWidth ());
+  txVector.SetNss (m_heSig.GetNStreams ());
+  txVector.SetGuardInterval (m_heSig.GetGuardInterval ());
+  txVector.SetBssColor (m_heSig.GetBssColor ());
+  txVector.SetAggregation (m_psdus.size () > 1 || m_psdus.begin ()->second->IsAggregate ());
+  for (auto const& muUserInfo : m_muUserInfos)
+    {
+      txVector.SetHeMuUserInfo (muUserInfo.first, muUserInfo.second);
+    }
+  return txVector;
+}
+
+Time
+HePpdu::GetTxDuration (void) const
+{
+  Time ppduDuration = Seconds (0);
+  const WifiTxVector& txVector = GetTxVector ();
+  Time tSymbol = NanoSeconds (12800 + txVector.GetGuardInterval ());
+  Time preambleDuration = WifiPhy::CalculatePhyPreambleAndHeaderDuration (txVector);
+  uint8_t sigExtension = 0;
+  if (m_band == WIFI_PHY_BAND_2_4GHZ)
+    {
+      sigExtension = 6;
+    }
+  uint8_t m = IsDlMu () ? 1 : 2;
+  //Equation 27-11 of IEEE P802.11ax/D4.0
+  Time calculatedDuration = MicroSeconds (((ceil (static_cast<double> (m_lSig.GetLength () + 3 + m) / 3)) * 4) + 20 + sigExtension);
+  uint32_t nSymbols = floor (static_cast<double> ((calculatedDuration - preambleDuration).GetNanoSeconds () - (sigExtension * 1000)) / tSymbol.GetNanoSeconds ());
+  ppduDuration = preambleDuration + (nSymbols * tSymbol) + MicroSeconds (sigExtension);
+  return ppduDuration;
+}
+
+Ptr<WifiPpdu>
+HePpdu::Copy (void) const
+{
+  return Create<HePpdu> (m_psdus, GetTxVector (), GetTxDuration (), m_band, m_uid, m_txPsdFlag);
+}
+
+WifiPpduType
+HePpdu::GetType (void) const
+{
+  switch (m_preamble)
+    {
+      case WIFI_PREAMBLE_HE_MU:
+        return WIFI_PPDU_TYPE_DL_MU;
+      case WIFI_PREAMBLE_HE_TB:
+        return WIFI_PPDU_TYPE_UL_MU;
+      default:
+        return WIFI_PPDU_TYPE_SU;
+    }
+}
+
+bool
+HePpdu::IsMu (void) const
+{
+  return (IsDlMu () || IsUlMu ());
+}
+
+bool
+HePpdu::IsDlMu (void) const
+{
+  return (m_preamble == WIFI_PREAMBLE_HE_MU);
+}
+
+bool
+HePpdu::IsUlMu (void) const
+{
+  return (m_preamble == WIFI_PREAMBLE_HE_TB);
+}
+
+Ptr<const WifiPsdu>
+HePpdu::GetPsdu (uint8_t bssColor, uint16_t staId /* = SU_STA_ID */) const
+{
+  if (!IsMu ())
+    {
+      NS_ASSERT (m_psdus.size () == 1);
+      return m_psdus.at (SU_STA_ID);
+    }
+  else if (IsUlMu ())
+    {
+      NS_ASSERT (m_psdus.size () == 1);
+      if (bssColor == 0 || m_heSig.GetBssColor () == 0 || (bssColor == m_heSig.GetBssColor ()))
+        {
+          return m_psdus.begin ()->second;
+        }
+    }
+  else
+    {
+      if (bssColor == 0 || m_heSig.GetBssColor () == 0 || (bssColor == m_heSig.GetBssColor ()))
+        {
+          auto it = m_psdus.find (staId);
+          if (it != m_psdus.end ())
+            {
+              return it->second;
+            }
+        }
+    }
+  return nullptr;
+}
+
+uint16_t
+HePpdu::GetStaId (void) const
+{
+  NS_ASSERT (IsUlMu ());
+  return m_psdus.begin ()->first;
+}
+
+uint16_t
+HePpdu::GetTransmissionChannelWidth (void) const
+{
+  WifiTxVector txVector = GetTxVector ();
+  if (txVector.GetPreambleType () == WIFI_PREAMBLE_HE_TB && GetStaId () != SU_STA_ID)
+    {
+      TxPsdFlag flag = GetTxPsdFlag ();
+      NS_ASSERT (flag > PSD_NON_HE_TB);
+      uint16_t ruWidth = HeRu::GetBandwidth (txVector.GetRu (GetStaId ()).GetRuType ());
+      uint16_t channelWidth = (flag == PSD_HE_TB_NON_OFDMA_PORTION && ruWidth < 20) ? 20 : ruWidth;
+      NS_LOG_INFO ("Use channelWidth=" << channelWidth << " MHz for HE TB from " << GetStaId ()
+                                       << " for " << flag);
+      return channelWidth;
+    }
+  else
+    {
+      return OfdmPpdu::GetTransmissionChannelWidth ();
+    }
+}
+
+bool
+HePpdu::CanBeReceived (uint16_t txCenterFreq, uint16_t p20MinFreq, uint16_t p20MaxFreq) const
+{
+  NS_LOG_FUNCTION (this << txCenterFreq << p20MinFreq << p20MaxFreq);
+
+  if (GetTxVector ().IsUlMu ())
+    {
+      // APs are able to receive TB PPDUs sent on a band other than the primary20 channel
+      return true;
+    }
+  return OfdmPpdu::CanBeReceived (txCenterFreq, p20MinFreq, p20MaxFreq);
+}
+
+HePpdu::TxPsdFlag
+HePpdu::GetTxPsdFlag (void) const
+{
+  return m_txPsdFlag;
+}
+
+void
+HePpdu::SetTxPsdFlag (TxPsdFlag flag)
+{
+  NS_LOG_FUNCTION (this << flag);
+  NS_ASSERT ((IsUlMu () && flag > PSD_NON_HE_TB) || (!IsUlMu () && flag == PSD_NON_HE_TB));
+  m_txPsdFlag = flag;
+}
+
+std::string
+HePpdu::PrintPayload (void) const
+{
+  std::ostringstream ss;
+  if (IsMu ())
+    {
+      ss << m_psdus;
+      ss << ", " << m_txPsdFlag;
+    }
+  else
+    {
+      ss << "PSDU=" << m_psdus.at (SU_STA_ID) << " ";
+    }
+  return ss.str ();
+}
+
+HePpdu::HeSigHeader::HeSigHeader ()
+  : m_format (1),
+    m_bssColor (0),
+    m_ul_dl (0),
+    m_mcs (0),
+    m_spatialReuse (0),
+    m_bandwidth (0),
+    m_gi_ltf_size (0),
+    m_nsts (0),
+    m_mu (false)
+{
+}
+
+HePpdu::HeSigHeader::~HeSigHeader ()
+{
+}
+
+TypeId
+HePpdu::HeSigHeader::GetTypeId (void)
+{
+  static TypeId tid = TypeId ("ns3::HeSigHeader")
+    .SetParent<Header> ()
+    .SetGroupName ("Wifi")
+    .AddConstructor<HeSigHeader> ()
+  ;
+  return tid;
+}
+
+TypeId
+HePpdu::HeSigHeader::GetInstanceTypeId (void) const
+{
+  return GetTypeId ();
+}
+
+void
+HePpdu::HeSigHeader::Print (std::ostream &os) const
+{
+  os << "MCS=" << +m_mcs
+     << " CHANNEL_WIDTH=" << GetChannelWidth ()
+     << " GI=" << GetGuardInterval ()
+     << " NSTS=" << +m_nsts
+     << " BSSColor=" << +m_bssColor
+     << " MU=" << +m_mu;
+}
+
+uint32_t
+HePpdu::HeSigHeader::GetSerializedSize (void) const
+{
+  uint32_t size = 0;
+  size += 4; //HE-SIG-A1
+  size += 4; //HE-SIG-A2
+  if (m_mu)
+    {
+      size += 1; //HE-SIG-B
+    }
+  return size;
+}
+
+void
+HePpdu::HeSigHeader::SetMuFlag (bool mu)
+{
+  m_mu = mu;
+}
+
+void
+HePpdu::HeSigHeader::SetMcs (uint8_t mcs)
+{
+  NS_ASSERT (mcs <= 11);
+  m_mcs = mcs;
+}
+
+uint8_t
+HePpdu::HeSigHeader::GetMcs (void) const
+{
+  return m_mcs;
+}
+
+void
+HePpdu::HeSigHeader::SetBssColor (uint8_t bssColor)
+{
+  NS_ASSERT (bssColor < 64);
+  m_bssColor = bssColor;
+}
+
+uint8_t
+HePpdu::HeSigHeader::GetBssColor (void) const
+{
+  return m_bssColor;
+}
+
+void
+HePpdu::HeSigHeader::SetChannelWidth (uint16_t channelWidth)
+{
+  if (channelWidth == 160)
+    {
+      m_bandwidth = 3;
+    }
+  else if (channelWidth == 80)
+    {
+      m_bandwidth = 2;
+    }
+  else if (channelWidth == 40)
+    {
+      m_bandwidth = 1;
+    }
+  else
+    {
+      m_bandwidth = 0;
+    }
+}
+
+uint16_t
+HePpdu::HeSigHeader::GetChannelWidth (void) const
+{
+  if (m_bandwidth == 3)
+    {
+      return 160;
+    }
+  else if (m_bandwidth == 2)
+    {
+      return 80;
+    }
+  else if (m_bandwidth == 1)
+    {
+      return 40;
+    }
+  else
+    {
+      return 20;
+    }
+}
+
+void
+HePpdu::HeSigHeader::SetGuardIntervalAndLtfSize (uint16_t gi, uint8_t ltf)
+{
+  if (gi == 800 && ltf == 1)
+    {
+      m_gi_ltf_size = 0;
+    }
+  else if (gi == 800 && ltf == 2)
+    {
+      m_gi_ltf_size = 1;
+    }
+  else if (gi == 1600 && ltf == 2)
+    {
+      m_gi_ltf_size = 2;
+    }
+  else
+    {
+      m_gi_ltf_size = 3;
+    }
+}
+
+uint16_t
+HePpdu::HeSigHeader::GetGuardInterval (void) const
+{
+  if (m_gi_ltf_size == 3)
+    {
+      //we currently do not consider DCM nor STBC fields
+      return 3200;
+    }
+  else if (m_gi_ltf_size == 2)
+    {
+      return 1600;
+    }
+  else
+    {
+      return 800;
+    }
+}
+
+void
+HePpdu::HeSigHeader::SetNStreams (uint8_t nStreams)
+{
+  NS_ASSERT (nStreams <= 8);
+  m_nsts = (nStreams - 1);
+}
+
+uint8_t
+HePpdu::HeSigHeader::GetNStreams (void) const
+{
+  return (m_nsts + 1);
+}
+
+void
+HePpdu::HeSigHeader::Serialize (Buffer::Iterator start) const
+{
+  //HE-SIG-A1
+  uint8_t byte = m_format & 0x01;
+  byte |= ((m_ul_dl & 0x01) << 2);
+  byte |= ((m_mcs & 0x0f) << 3);
+  start.WriteU8 (byte);
+  uint16_t bytes = (m_bssColor & 0x3f);
+  bytes |= (0x01 << 6); //Reserved set to 1
+  bytes |= ((m_spatialReuse & 0x0f) << 7);
+  bytes |= ((m_bandwidth & 0x03) << 11);
+  bytes |= ((m_gi_ltf_size & 0x03) << 13);
+  bytes |= ((m_nsts & 0x01) << 15);
+  start.WriteU16 (bytes);
+  start.WriteU8 ((m_nsts >> 1) & 0x03);
+
+  //HE-SIG-A2
+  uint32_t sigA2 = 0;
+  sigA2 |= (0x01 << 14); //Set Reserved bit #14 to 1
+  start.WriteU32 (sigA2);
+
+  if (m_mu)
+    {
+      //HE-SIG-B
+      start.WriteU8 (0);
+    }
+}
+
+uint32_t
+HePpdu::HeSigHeader::Deserialize (Buffer::Iterator start)
+{
+  Buffer::Iterator i = start;
+
+  //HE-SIG-A1
+  uint8_t byte = i.ReadU8 ();
+  m_format = (byte & 0x01);
+  m_ul_dl = ((byte >> 2) & 0x01);
+  m_mcs = ((byte >> 3) & 0x0f);
+  uint16_t bytes = i.ReadU16 ();
+  m_bssColor = (bytes & 0x3f);
+  m_spatialReuse = ((bytes >> 7) & 0x0f);
+  m_bandwidth = ((bytes >> 11) & 0x03);
+  m_gi_ltf_size = ((bytes >> 13) & 0x03);
+  m_nsts = ((bytes >> 15) & 0x01);
+  byte = i.ReadU8 ();
+  m_nsts |= (byte & 0x03) << 1;
+
+  //HE-SIG-A2
+  i.ReadU32 ();
+
+  if (m_mu)
+    {
+      //HE-SIG-B
+      i.ReadU8 ();
+    }
+
+  return i.GetDistanceFrom (start);
+}
+
+} //namespace ns3
